/***************************************************************************
 *
 *  $Id: kzencategorydialog.h,v 1.3 2005/05/31 06:54:02 muszilla Exp $
 *
 *  Copyright (C) 2005 by Andreas Mussgiller
 *  muszilla@users.sourceforge.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the
 *  Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************/

#ifndef KZENCATEGORYDIALOG_H
#define KZENCATEGORYDIALOG_H

#include <kdialogbase.h>
#include <klistview.h>

#include <qptrlist.h>

#include "kzentrack.h"

class KZenCategoryDialog : public KDialogBase
{
  Q_OBJECT
    
 public:
 
  KZenCategoryDialog(QWidget* parent = 0,
		     const char* name = 0);
  virtual ~KZenCategoryDialog();
  
  uint                        count();
  bool                        isChecked(uint idx);
  void                        setChecked(uint idx, bool value);

  void                        setTrack(KZenTrack * track);

 protected:
  
  KListView                  *fCategories;
  QPtrList<QCheckListItem>    fItems;

 protected slots:
  
  void                        languageChange();
};

#endif
