/***************************************************************************
 *
 *  $Id: kzensearchwidget.h,v 1.3 2005/05/31 06:54:03 muszilla Exp $
 *
 *  Copyright (C) 2005 by Andreas Mussgiller
 *  muszilla@users.sourceforge.net
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the
 *  Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ***************************************************************************/

#ifndef KZENSEARCHWIDGET_H
#define KZENSEARCHWIDGET_H

#include <qvbox.h>

class KPushButton;
class QRadioButton;
class KZenSearch;
class KZenSearchLine;

/**
@author Andreas Mussgiller
*/
class KZenSearchWidget : public QVBox
{
  Q_OBJECT

 public:

  KZenSearchWidget(QWidget *parent = 0,
		   const char *name = 0);
  virtual ~KZenSearchWidget();

  void                        setSearch(KZenSearch *);

 protected slots:
 
  virtual void                modeChanged(int);
  virtual void                more();
  virtual void                fewer();

 protected:

  KZenSearch                 *fSearch;

  QWidget                    *fConditions;
  QRadioButton               *fMatchAllButton;
  QRadioButton               *fMatchAnyButton;
  KPushButton                *fMoreButton;
  KPushButton                *fFewerButton;
  QPtrList<KZenSearchLine>    fLines;
};

#endif
